------------------------------------------------------------------------------------------
-- psp-httpd, created by Elton Muuga / Elxx.net
------------------------------------------------------------------------------------------
-- network.lua - Functions for choosing and starting network connection
--               [Menu code originally created by modsyn]
------------------------------------------------------------------------------------------
-- Note that this app uses a customized version of the LuaPlayer source, thus it will not 
-- work using an official release of LuaPlayer. You must use the included EBOOT.PBP.
------------------------------------------------------------------------------------------

os = Image.createEmpty(480, 272)
os:clear(black)
selected=1
chosen=false
state=0
quit=false
configs = Wlan.getConnectionConfigs()

function clear()
	os:clear(Color.new(0, 0, 0))
end

function chooseNetwork(lid)
	
	clear()

	-- init WLAN and choose connection config
	if (lid == 0) then
		repeat
			getState()
			updateConnections()
			if quit then break end
		until state==1
	else
		-- use the profile in the config file
		selected = lid
	end
	
	clear()
	os:print(0,0,"Initializing WLAN and connecting to '" .. configs[selected] .. "'...",blue)
	os:print(0,20,"PSP-HTTPD will try to connect to your wireless network",white)
	os:print(0,30,"up to 3 times. If it fails, you need to check your",white)
	os:print(0,40,"network settings.",white)
	screen:blit(0, 0, os)
	screen.waitVblankStart()
	screen.flip()
	attempts = 0
	conn_result = nil
	while conn_result ~= 1 do
		conn_result = Wlan.useConnectionConfig(selected)
		if not conn_result then
			attempts = attempts + 1
			os:print(0,50 + (10 * attempts),"Connection attempt " .. attempts .. " failed.",red)
			screen:blit(0, 0, os)
			screen.waitVblankStart()
			screen.flip()
			if attempts > 2 then
				os:print(0,50 + (10 * attempts) + 20,"Unable to connect to WLAN.",red)
				screen:blit(0, 0, os)
				screen.waitVblankStart()
				screen.flip()
				System.sleep(2000)
				return "f"
			end
			-- Wait 1 second before trying again
			System.sleep(1000)
		end
	end
	return "t"
end

function updateConnections()
	local i=1
	for key, value in configs do
		os:print(13,i*8 + 30,"  [".. i .. "]: " .. value, white)
		screen:blit(0, 0, os)
		screen.waitVblankStart()
		screen.flip()
		if i == selected then
			os:print(0,i*8 + 30,">>",blue)
		else
			os:print(0,i*8 + 30,">>",black)
		end
		i = i+1
	end
end

function getState()
	os:print(0, 0, "Choose the WLAN profile to use. Press X if you do not", white)
	os:print(0, 10, "want to be prompted again during this session,", white)
	os:print(0, 20, "otherwise press O.", white)
	screen:blit(0, 0, os)
	screen.waitVblankStart()
	screen.flip()
	lim=table.getn(configs)
	local pad = Controls.read()
	if pad ~= oldPad then
		if pad:cross() then
			saveProfile=true
			state=1
		elseif pad:circle() then
			state=1
		elseif pad:start() then quit = true
		elseif pad:down() then
			if selected < lim then selected = selected+1 end
		elseif pad:up() then
			if selected > 1 then selected = selected-1 end
		end
	end
	oldPad = pad
	return 0
end